var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var Rxjs_1 = require('Rxjs');
var decorator_1 = require('./decorator');
var config_1 = require('./config');
var BaseStore = (function () {
    function BaseStore() {
        this.list = new Rxjs_1.BehaviorSubject([]);
        this.events = new Rxjs_1.Observable();
        this.events = this._eventEmitterFromActions();
        this.size = this.list.map(this._itemsLength);
    }
    BaseStore.prototype.add = function (newItem) {
        this.list.next(this.list.getValue().concat([newItem]));
    };
    BaseStore.prototype.remove = function (itemToRemove) {
        this.list.next(this.list.getValue().filter(function (item) { return item !== itemToRemove; }));
    };
    BaseStore.prototype.update = function (itemToUpdate, upatedItem) {
        this.list.next(this.list.getValue().map(function (item) {
            if (item === itemToUpdate)
                return upatedItem;
            return item;
        }));
    };
    BaseStore.prototype._itemsLength = function (items) {
        return items.length;
    };
    BaseStore.prototype._eventEmitterFromActions = function () {
        if (!this[config_1.ACTION_EVENT_LIST_ID])
            return Rxjs_1.Observable.empty();
        return Rxjs_1.Observable.merge.apply(Rxjs_1.Observable, this[config_1.ACTION_EVENT_LIST_ID]);
    };
    __decorate([
        decorator_1.Action, 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', [Object]), 
        __metadata('design:returntype', void 0)
    ], BaseStore.prototype, "add", null);
    __decorate([
        decorator_1.Action, 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', [Object]), 
        __metadata('design:returntype', void 0)
    ], BaseStore.prototype, "remove", null);
    __decorate([
        decorator_1.Action, 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', [Object, Object]), 
        __metadata('design:returntype', void 0)
    ], BaseStore.prototype, "update", null);
    return BaseStore;
})();
exports.BaseStore = BaseStore;
//# sourceMappingURL=base-service.js.map